<COMPONENT>
	<HEADER
		PLATEFORM="ALL"
		SERIAL=""
		VERSION="0.102"
		STATUS="ALPHA"
		COMPATIBILITY="ALL"
		AUTHOR="Talend"
		RELEASE_DATE="20070719A"
		STARTABLE="false"
		DATA_AUTO_PROPAGATE="false"
		HAS_CONDITIONAL_OUTPUTS="true"
		PARALLELIZE="true"
		PARTITIONING="AUTO"
		LOG4J_ENABLED="true"
	>
		<SIGNATURE/>
	</HEADER>

	<FAMILIES>
		<FAMILY>Databases/DB Specifics/PostgreSQL</FAMILY>
	</FAMILIES>

	<DOCUMENTATION>
		<URL/>
	</DOCUMENTATION>

	<CONNECTORS>
		<CONNECTOR CTYPE="FLOW" MAX_INPUT="1" MAX_OUTPUT="1"/>
		<CONNECTOR NAME="REJECT" CTYPE="FLOW" MAX_INPUT="0" MAX_OUTPUT="1" LINE_STYLE="2" COLOR="FF0000" BASE_SCHEMA="FLOW"
	 			NOT_SHOW_IF="((((DATA_ACTION == 'INSERT') AND (USE_BATCH_SIZE == 'true')) OR ((DATA_ACTION == 'UPDATE') AND (USE_BATCH_SIZE == 'true'))
								OR ((DATA_ACTION == 'DELETE') AND (USE_BATCH_SIZE == 'true')))
								OR (DIE_ON_ERROR == 'true'))"/>
		<CONNECTOR CTYPE="ITERATE" MAX_OUTPUT="0" MAX_INPUT="0"/>
		<CONNECTOR CTYPE="SUBJOB_OK" MAX_INPUT="1" />
		<CONNECTOR CTYPE="SUBJOB_ERROR" MAX_INPUT="1" />
		<CONNECTOR CTYPE="COMPONENT_OK"/>
		<CONNECTOR CTYPE="COMPONENT_ERROR"/>
		<CONNECTOR CTYPE="RUN_IF"/>
	</CONNECTORS>

	<PARAMETERS>
		<PARAMETER
			NAME="PROPERTY"
			FIELD="PROPERTY_TYPE"
			NUM_ROW="1"
			REPOSITORY_VALUE="DATABASE:POSTGRESQL"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
		/>

		<PARAMETER
			NAME="USE_EXISTING_CONNECTION"
			FIELD="CHECK"
			NUM_ROW="2"
		>
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="CONNECTION"
			FIELD="COMPONENT_LIST"
			REQUIRED="true" FILTER="tPostgresqlConnection"
			NUM_ROW="2"
			SHOW_IF="USE_EXISTING_CONNECTION == 'true'"
			DYNAMIC_SETTINGS="true"
		/>

		<PARAMETER
			NAME="DB_VERSION"
			FIELD="CLOSED_LIST"
			NUM_ROW="5"
			REPOSITORY_VALUE="DB_VERSION"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'">
			<ITEMS DEFAULT="V9_X">
				<ITEM NAME="PRIOR_TO_V9" VALUE="PRIOR_TO_V9" />
				<ITEM NAME="V9_X" VALUE="V9_X" />
			</ITEMS>
		</PARAMETER>

		<PARAMETER
			NAME="HOST"
			FIELD="TEXT"
			NUM_ROW="10"
			REPOSITORY_VALUE="SERVER_NAME"
			REQUIRED="true"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
		>
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="PORT"
			FIELD="TEXT"
				NUM_ROW="10"
			REPOSITORY_VALUE="PORT"
			REQUIRED="true"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
		>
			<DEFAULT>"5432"</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="DBNAME"
			FIELD="TEXT"
			NUM_ROW="15"
			REPOSITORY_VALUE="SID"
			REQUIRED="true"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
		>
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="TYPE"
			FIELD="TEXT"
			NUM_ROW="15"
			SHOW="false"
			REPOSITORY_VALUE="TYPE"
		>
			<DEFAULT>PostgreSQL</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="SCHEMA_DB"
			FIELD="TEXT"
			NUM_ROW="15"
			REPOSITORY_VALUE="SCHEMA"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
		>
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="USER"
			FIELD="TEXT"
			NUM_ROW="20"
			REPOSITORY_VALUE="USERNAME"
			REQUIRED="true"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
		>
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="PASS"
			FIELD="PASSWORD"
			NUM_ROW="20"
			REPOSITORY_VALUE="PASSWORD"
			REQUIRED="true"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
		>
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="TABLE"
			FIELD="DBTABLE"
			NUM_ROW="25"
			REQUIRED="true"
		>
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="TABLE_ACTION"
			FIELD="CLOSED_LIST"
			NUM_ROW="30"
			NOT_SHOW_IF="PARALLELIZE == 'true'"
		>
			<ITEMS DEFAULT="NONE">
				<ITEM NAME="NONE" VALUE="NONE" />
				<ITEM NAME="DROP_CREATE" VALUE="DROP_CREATE"/>
				<ITEM NAME="CREATE" VALUE="CREATE"/>
				<ITEM NAME="CREATE_IF_NOT_EXISTS" VALUE="CREATE_IF_NOT_EXISTS"/>
				<ITEM NAME="DROP_IF_EXISTS_AND_CREATE" VALUE="DROP_IF_EXISTS_AND_CREATE" />
				<ITEM NAME="CLEAR" VALUE="CLEAR"/>
				<ITEM NAME="TRUNCATE" VALUE="TRUNCATE"/>
			</ITEMS>
		</PARAMETER>

		<PARAMETER
			NAME="DATA_ACTION"
			FIELD="CLOSED_LIST"
			NUM_ROW="30"
		>
			<ITEMS DEFAULT="INSERT">
				<ITEM NAME="INSERT" VALUE="INSERT" />
				<ITEM NAME="UPDATE" VALUE="UPDATE"/>
				<ITEM NAME="INSERT_OR_UPDATE" VALUE="INSERT_OR_UPDATE"/>
				<ITEM NAME="UPDATE_OR_INSERT" VALUE="UPDATE_OR_INSERT"/>
				<ITEM NAME="DELETE" VALUE="DELETE"/>
			</ITEMS>
		</PARAMETER>

		<PARAMETER
			NAME="SCHEMA_FLOW"
			FIELD="SCHEMA_TYPE"
			NUM_ROW="35"
		>
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="SCHEMA_REJECT"
			FIELD="SCHEMA_TYPE"
			REQUIRED="true"
			NUM_ROW="35"
			CONTEXT="REJECT"
			SHOW="true">
			<TABLE READONLY="true">
				<COLUMN NAME="errorCode" TYPE="id_String" LENGTH="255" READONLY="false" CUSTOM="true"/>
				<COLUMN NAME="errorMessage" TYPE="id_String" LENGTH="255" READONLY="false" CUSTOM="true"/>
			</TABLE>
		</PARAMETER>

		<PARAMETER
			NAME="USE_SPATIAL_OPTIONS"
			FIELD="CHECK"
			NUM_ROW="40"
			NOT_SHOW_IF="(PARALLELIZE == 'true') or ((TABLE_ACTION!='CREATE') and (TABLE_ACTION!='DROP_CREATE') and
					(TABLE_ACTION!='CREATE_IF_NOT_EXISTS') and (TABLE_ACTION!='DROP_IF_EXISTS_AND_CREATE'))"
		>
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="SPATIAL_INDEX"
			FIELD="CHECK"
			NOT_SHOW_IF="((PARALLELIZE == 'true') or (USE_SPATIAL_OPTIONS == 'false')) or ((TABLE_ACTION!='CREATE') and (TABLE_ACTION!='DROP_CREATE') and
					(TABLE_ACTION!='CREATE_IF_NOT_EXISTS') and (TABLE_ACTION!='DROP_IF_EXISTS_AND_CREATE'))"
			NUM_ROW="40"
		>
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="GEOMETRY_COLUMNS"
			FIELD="CHECK"
			NOT_SHOW_IF="((PARALLELIZE == 'true') or (USE_SPATIAL_OPTIONS == 'false')) or ((TABLE_ACTION!='CREATE') and (TABLE_ACTION!='DROP_CREATE') and
					(TABLE_ACTION!='CREATE_IF_NOT_EXISTS') and (TABLE_ACTION!='DROP_IF_EXISTS_AND_CREATE'))"
			NUM_ROW="40"
		>
			<DEFAULT>false</DEFAULT>
		</PARAMETER>
		
	    <PARAMETER
		  NAME="NOTE"
	      FIELD="LABEL"
	      NUM_ROW="50"
		  GROUP="DATASOURCE"
		  SHOW_IF="USE_EXISTING_CONNECTION=='false'"
	    >
	    	<DEFAULT>This option only applies when deploying and running in the Talend Runtime</DEFAULT>
	    </PARAMETER>
	    
		<PARAMETER
	      NAME="SPECIFY_DATASOURCE_ALIAS"
		  FIELD="CHECK"
	      NUM_ROW="52"
	      REQUIRED="true"
		  GROUP="DATASOURCE"
		  SHOW_IF="USE_EXISTING_CONNECTION=='false'"
	    >
	    </PARAMETER>
	    
		<PARAMETER
	      NAME="DATASOURCE_ALIAS"
		  FIELD="TEXT"
	      NUM_ROW="54"
	      REQUIRED="true"
		  GROUP="DATASOURCE"
		  SHOW_IF="(SPECIFY_DATASOURCE_ALIAS=='true' AND USE_EXISTING_CONNECTION=='false')"
	    >
			<DEFAULT>""</DEFAULT>
	    </PARAMETER>

		<PARAMETER
			NAME="DIE_ON_ERROR"
			FIELD="CHECK"
			NUM_ROW="90"
		>
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="MAPPING"
			FIELD="MAPPING_TYPE"
			NUM_ROW="100"
			SHOW="false"
		>
			<DEFAULT>postgres_id</DEFAULT>
		</PARAMETER>

	</PARAMETERS>

	<ADVANCED_PARAMETERS>
	
		<PARAMETER
			NAME="USE_ALTERNATE_SCHEMA"
			FIELD="CHECK"
			NUM_ROW="1"
			SHOW_IF="USE_EXISTING_CONNECTION == 'true'"
		>
			<DEFAULT>false</DEFAULT>
		</PARAMETER>
		
		<PARAMETER
			NAME="ALTERNATE_SCHEMA"
			FIELD="TEXT"
			NUM_ROW="2"
			SHOW_IF="(USE_EXISTING_CONNECTION == 'true') AND (USE_ALTERNATE_SCHEMA == 'true')"
		>
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="PROPERTIES"
			FIELD="TEXT"
			NUM_ROW="5"
			REPOSITORY_VALUE="PROPERTIES_STRING"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'">
			<DEFAULT>""</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="SAVE_POINT"
			FIELD="CHECK"
			NUM_ROW="11"
			SHOW_IF="(USE_BATCH_SIZE == 'false') AND (DIE_ON_ERROR == 'false')"
		>
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="ENCODING"
			FIELD="ENCODING_TYPE"
			NUM_ROW="9"
			REQUIRED="true"
			SHOW="false"
		>
			<DEFAULT>"ISO-8859-15"</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="COMMIT_EVERY"
			FIELD="TEXT"
			NUM_ROW="9"
			REQUIRED="true"
			SHOW_IF="USE_EXISTING_CONNECTION == 'false'"
		>
			<DEFAULT>10000</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="ADD_COLS"
			FIELD="TABLE"
			REQUIRED="false"
			NUM_ROW="10"
			NB_LINES="3"
		>
			<ITEMS>
				<ITEM NAME="NAME" VALUE='"colname"' />
				<ITEM NAME="DATATYPE" VALUE="VARCHAR(50)" RAW="true" NOT_SHOW_IF="(TABLE_ACTION=='NONE') or (TABLE_ACTION=='CLEAR')"/>
				<ITEM NAME="SQL" VALUE='"now()"' />
				<ITEM NAME="POS" FIELD="CLOSED_LIST">
					<ITEMS DEFAULT="BEFORE">
						<ITEM NAME="BEFORE" VALUE="BEFORE"/>
						<ITEM NAME="AFTER" VALUE="AFTER"/>
						<ITEM NAME="REPLACE" VALUE="REPLACE"/>
					</ITEMS>
				</ITEM>
				<ITEM NAME="REFCOL" FIELD="COLUMN_LIST" />
			</ITEMS>
		</PARAMETER>

		<PARAMETER
			NAME="USE_FIELD_OPTIONS"
			FIELD="CHECK"
			NUM_ROW="12"
		>
			<DEFAULT>false</DEFAULT>
		</PARAMETER>
	
		<PARAMETER
			NAME="FIELD_OPTIONS"
			FIELD="TABLE"
			REQUIRED="true"
			NUM_ROW="13"
			NB_LINES="5"
			SHOW_IF="USE_FIELD_OPTIONS == 'true'"
		>
			<ITEMS BASED_ON_SCHEMA="true">
				<ITEM NAME="UPDATE_KEY" VALUE="false" FIELD="CHECK" />
				<ITEM NAME="DELETE_KEY" VALUE="false" FIELD="CHECK" />
				<ITEM NAME="UPDATABLE" VALUE="true" FIELD="CHECK" />
				<ITEM NAME="INSERTABLE" VALUE="true" FIELD="CHECK" />
			</ITEMS>
		</PARAMETER>

		<PARAMETER
			NAME="ENABLE_DEBUG_MODE"
			FIELD="CHECK"
			NUM_ROW="15">
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER
			NAME="SUPPORT_NULL_WHERE"
			FIELD="CHECK"
			NUM_ROW="20">
			<DEFAULT>false</DEFAULT>
		</PARAMETER>

		<PARAMETER
	      NAME="CONVERT_COLUMN_TABLE_TO_LOWERCASE"
	      FIELD="CHECK"
	      NUM_ROW="25"
	    >
	      <DEFAULT>false</DEFAULT>
	    </PARAMETER>

		<PARAMETER
			NAME="USE_BATCH_SIZE"
			FIELD="CHECK"
			NUM_ROW="30"
			SHOW_IF="((DATA_ACTION == 'INSERT') OR (DATA_ACTION == 'UPDATE') OR (DATA_ACTION == 'DELETE')) "
			>
			<DEFAULT>true</DEFAULT>
		</PARAMETER>
		<PARAMETER
			NAME="BATCH_SIZE"
			FIELD="TEXT"
			NUM_ROW="30"
			SHOW_IF="(USE_BATCH_SIZE == 'true')AND ((DATA_ACTION == 'INSERT') OR (DATA_ACTION == 'UPDATE') OR (DATA_ACTION == 'DELETE'))"
			>
			<DEFAULT>10000</DEFAULT>
		</PARAMETER>

	</ADVANCED_PARAMETERS>

	<CODEGENERATION>
		<IMPORTS>
			<IMPORT NAME="Driver-Postgres9" MODULE="postgresql-42.2.5.jar" MVN="mvn:org.postgresql/postgresql/42.2.5" REQUIRED_IF="(DB_VERSION =='V9_X') AND (USE_EXISTING_CONNECTION == 'false')" />
			<IMPORT NAME="Driver-Postgres" MODULE="postgresql-8.4-703.jdbc4.jar" MVN="mvn:postgresql/postgresql/8.4-703.jdbc4" REQUIRED_IF="(DB_VERSION =='PRIOR_TO_V9') AND (USE_EXISTING_CONNECTION == 'false')" />
			<IMPORT NAME="Driver-Postgis" MODULE="postgis_1.4.0.jar" MVN="mvn:org.talend.libraries/postgis_1.4.0/6.0.0"  REQUIRED="false" />
		 	<IMPORT NAME="org.talend.sdi" MODULE="org.talend.sdi.jar" MVN="mvn:org.talend.libraries/org.talend.sdi/6.0.0"  REQUIRED="false" />
		 	<IMPORT NAME="jts" MODULE="jts-1.12.jar" MVN="mvn:org.talend.libraries/jts-1.12/6.0.0"  REQUIRED="false"/>
		</IMPORTS>
	</CODEGENERATION>

	<RETURNS>
		<RETURN NAME="NB_LINE"	TYPE="id_Integer" AVAILABILITY="AFTER"/>
		<RETURN NAME="NB_LINE_UPDATED"	TYPE="id_Integer" AVAILABILITY="AFTER"/>
		<RETURN NAME="NB_LINE_INSERTED"	TYPE="id_Integer" AVAILABILITY="AFTER"/>
		<RETURN NAME="NB_LINE_DELETED"	TYPE="id_Integer" AVAILABILITY="AFTER"/>
		<RETURN NAME="NB_LINE_REJECTED"	TYPE="id_Integer" AVAILABILITY="AFTER"/>
		<RETURN NAME="QUERY" TYPE="id_String" AVAILABILITY="FLOW" SHOW_IF="ENABLE_DEBUG_MODE=='true'"/>
	</RETURNS>
</COMPONENT>
